Package: numDeriv
Version: 2016.8-1.1
Title: Accurate Numerical Derivatives
Description: Methods for calculating (usually) accurate
	numerical first and second order derivatives. Accurate calculations 
	are done using 'Richardson''s' extrapolation or, when applicable, a
	complex step derivative is available. A simple difference 
	method is also provided. Simple difference is (usually) less accurate
	but is much quicker than 'Richardson''s' extrapolation and provides a 
	useful cross-check. 
	Methods are provided for real scalar and vector valued functions. 
Depends: R (>= 2.11.1)
LazyLoad: yes
ByteCompile: yes
License: GPL-2
Copyright: 2006-2011, Bank of Canada. 2012-2016, Paul Gilbert
Author: Paul Gilbert and Ravi Varadhan
Maintainer: Paul Gilbert <pgilbert.ttv9z@ncf.ca>
URL: http://optimizer.r-forge.r-project.org/
NeedsCompilation: no
Packaged: 2019-06-04 11:04:44 UTC; hornik
Repository: CRAN
Date/Publication: 2019-06-06 09:51:09 UTC
Built: R 4.6.0; ; 2026-04-26 08:50:41 UTC; unix

# test one-sided derivatives

 library(numDeriv)

fuzz <- 1e-8

##### scalar argument, scalar result (case 1)#####
 f <- function(x) if(x<=0) sin(x) else  NA 
################################################## 

## grad

err <- 1.0 - grad(f, x=0,    method="simple", side=-1) 
if( fuzz < err )    stop("grad case 1 method simple one-sided test 1 failed.")

if( ! is.na(grad(f, x=0, method="simple", side=1)))  stop("grad case 1 method simple one-sided test 2 failed.")  

err <- 1.0 - grad(f, x=0,    method="Richardson", side=-1)
if( fuzz < err ) stop("grad case 1 method Richardson one-sided test 1 failed.")

# print(grad(sin, x=-0.5, method="Richardson")         , digits=16)  # 0.8775825618862814
# print(grad(sin, x=-0.5, method="Richardson", side=-1), digits=16)  # 0.8775807270501326

err <- 0.8775807270501326 - grad(sin, x=-0.5, method="Richardson", side=-1)
if( fuzz < err ) stop("grad case 1 method Richardson one-sided test 2 failed.")


## jacobian

err <- 1.0 - jacobian(f, x=0,    method="simple", side= -1)
if( fuzz < err ) stop("jacobian case 1 method simple one-sided test failed.")

err <- 1.0 - jacobian(f, x=0,    method="Richardson", side= -1)
if( fuzz < err ) stop("jacobian case 1 method Richardson one-sided test 1 failed.")

if( ! is.na(jacobian(f, x=0, method="Richardson", side= 1))) stop("jacobian case 1 method Richardson one-sided test 2 failed.")



##### vector argument, vector result (case 3)#####
 f <- function(x) if(x[1]<=0) sin(x) else  c(NA, sin(x[-1]))
################################################## 

## grad

err <- 1.0 -  grad(f, x=c(0,0), method="simple", side=c(-1, -1))  #  1 1
if( fuzz < max(err) )  stop("grad case 3 method simple one-sided test 1 failed.")

err <- 1.0 -  grad(f, x=c(0,0), method="simple", side=c(-1,  1))  #  1 1
if( fuzz < max(err) )  stop("grad case 3 method simple one-sided test 2 failed.")

err <- 1.0 -  grad(f, x=c(0,0), method="simple", side=c(-1, NA))  #  1 1
if( fuzz < max(err) )  stop("grad case 3 method simple one-sided test 3 failed.")

err <- 1.0 -  grad(f, x=c(0,0), method="simple", side=c( 1,  1))  #  NA 1
if( fuzz < err[2] )    stop("grad case 3 method simple one-sided test 4 failed.")
if(!is.na( err[1]) )   stop("grad case 3 method simple one-sided test 4b failed.")


err <- 1.0 -  grad(f, x=c(0,0), method="Richardson", side=c(-1, -1)) #   1 1 
if( fuzz < max(err) )  stop("grad case 3 method Richardson one-sided test 1 failed.")

err <- 1.0 -  grad(f, x=c(0,0), method="Richardson", side=c(-1,  1)) #  1 1
if( fuzz < max(err) )  stop("grad case 3 method Richardson one-sided test 2 failed.")

err <- 1.0 -  grad(f, x=c(0,0), method="Richardson", side=c(-1, NA)) #  1 1
if( fuzz < max(err) )  stop("grad case 3 method Richardson one-sided test 3 failed.")

## jacobian

err <- 1.0 - jacobian(f, x=0,    method="simple", side= -1)
if( fuzz < err ) stop("jacobian case 3 method simple one-sided test failed.")

err <- 1.0 - jacobian(f, x=0,    method="Richardson", side= -1)
if( fuzz < err ) stop("jacobian case 3 method Richardson one-sided test 1 failed.")

if( ! is.na(jacobian(f, x=0, method="Richardson", side= 1))) stop("jacobian case 3 method Richardson one-sided test 2 failed.")



##### vector argument, scalar result (case 2)#####
 f <- function(x) if(x[1]<=0) sum(sin(x)) else  NA
################################################## 
 
## grad

err <- 1.0 - grad(f, x=c(0,0), method="simple", side=c(-1, -1))  #  1 1
if( fuzz < max(err) )  stop("grad case 2 method simple one-sided test 1 failed.")

err <- 1.0 - grad(f, x=c(0,0), method="simple", side=c(-1,  1))  #  1 1
if( fuzz < max(err) )  stop("grad case 2 method simple one-sided test 2 failed.")

err <- 1.0 - grad(f, x=c(0,0), method="simple", side=c(-1, NA))  #  1 1
if( fuzz < max(err) )  stop("grad case 2 method simple one-sided test 3 failed.")

err <- 1.0 - grad(f, x=c(0,0), method="simple", side=c( 1,  1))  #  NA 1
if( fuzz < err[2] )  stop("grad case 2 method simple one-sided test 4 failed.")
if(!is.na( err[1]) ) stop("grad case 2 method simple one-sided test 4b failed.")


err <- 1.0 - grad(f, x=c(0,0), method="Richardson", side=c(-1, -1)) #  1 1 
if( fuzz < max(err) )  stop("grad case 2 method Richardson one-sided test 1 failed.")

err <- 1.0 - grad(f, x=c(0,0), method="Richardson", side=c(-1,  1)) #  1 1
if( fuzz < max(err) )  stop("grad case 2 method Richardson one-sided test 2 failed.")

err <- 1.0 - grad(f, x=c(0,0), method="Richardson", side=c(-1, NA)) #  1 1
if( fuzz < max(err) )  stop("grad case 2 method Richardson one-sided test 3 failed.")

## jacobian

err <- 1.0 - jacobian(f, x=0,    method="simple", side= -1)
if( fuzz < err ) stop("jacobian case 2 method simple one-sided test failed.")

err <- 1.0 - jacobian(f, x=0,    method="Richardson", side= -1)
if( fuzz < err ) stop("jacobian case 2 method Richardson one-sided test 1 failed.")

if( ! is.na(jacobian(f, x=0, method="Richardson", side= 1))) stop("jacobian case 2 method Richardson one-sided test 2 failed.")

#  check jacobian

if(!require("numDeriv"))stop("this test requires numDeriv.")

x <- pi
print(j.calc <- jacobian(sin, x))
cat("error: ", err <- max(abs(j.calc - cos(x))),"\n")
if( err > 1e-11) stop("jacobian matrix test 1 FAILED") # 1e-13 with d=0.01

x <- (1:2)*2*pi/2
print(j.calc <- jacobian(sin, x))
cat("error: ", err <- max(abs(j.calc -  diag(cos(x)))),"\n")
if( err > 1e-11) stop("jacobian matrix test 2 FAILED") # 1e-13 with d=0.01

func2 <- function(x) c(sin(x), cos(x))

x <- (1:2)*2*pi/2
print(j.calc <- jacobian(func2, x))
cat("error: ", err <- max(abs(j.calc - rbind(diag(cos(x)), diag(-sin(x))))),"\n")
if( err > 1e-11) stop("jacobian matrix test 3 FAILED") # 1e-13 with d=0.01

x <- (0:1)*2*pi
print(j.calc <- jacobian(func2, x))
cat("error: ", err <- max(abs(j.calc - rbind(diag(cos(x)), diag(-sin(x))))),"\n")
if( err > 1e-11) stop("jacobian matrix test 4 FAILED") # 1e-13 with d=0.01


x <- (0:10)*2*pi/10
print(j.calc <- jacobian(func2, x))
cat("error: ", err <- max(abs(j.calc - rbind(diag(cos(x)), diag(-sin(x))))),"\n")
if( err > 1e-10) stop("jacobian matrix test 5 FAILED")# 1e-12 with d=0.01

func3 <- function(x) sum(sin(x)) # R^n -> R

x <- (1:2)*2*pi/2
print(j.calc <- jacobian(func3, x))
cat("error: ", err <- max(abs(j.calc - cos(x))),"\n")
if( err > 1e-11) stop("jacobian matrix test 6 FAILED")# 1e-13 with d=0.01

require("numDeriv")

##### Example 0
set.seed(123)
f <- function(x) {
  n <- length(x)
  f <- rep(NA, n)
  vec <- 1:(n-1)
  f[vec] <- x[vec]^2 + (-1)^vec * x[vec]*exp(x[vec+1])
  f[n] <- x[n]*exp(x[n])
  f
  }

x0 <- runif(5)
ans1 <- jacobian(func=f, x=x0,  method="complex")
print(ans1, digits=18)
#max.diff1:  3.571277e-11 
ans2 <- jacobian(func=f, x=x0)

err <- max(abs(ans1 - ans2))
cat("max.diff1: ", err, "\n")
if (1e-10 < err ) stop("Example 0 jacobian test failed.")


###### Example 1
broydt <- function(x, h=0.5) {
        n <- length(x)
        f <- numeric(n)
        f[1] <- ((3 - h*x[1]) * x[1]) - 2*x[2] + 1
        tnm1 <- 2:(n-1)
        f[tnm1] <- ((3 - h*x[tnm1])*x[tnm1]) - x[tnm1-1] - 2*x[tnm1+1] + 1
        f[n] <- ((3 - h*x[n]) * x[n]) - x[n-1] + 1
        sum(f*f)
    }


set.seed(123)
p0 <- runif(10)

ans1 <- grad(func=broydt, x=p0, method="complex")
#print(ans1, digits=18)
ans2 <- grad(func=broydt, x=p0)

err <- max(abs(ans1 - ans2))
cat("max.diff1: ", err, "\n")
#max.diff1:  4.977583e-10 
##max.diff1:  9.386859e-09 
if (1e-8 < err ) stop("broydt gradient test failed.")


h1 <- hessian(func=broydt, x=p0, method="complex")
#print(h1, digits=18)
h2 <- hessian(func=broydt, x=p0)
#print(h2, digits=18)
err <- max(abs(h1 - h2))
#print(err, digits=18)

cat("max.diff1: ", err , "\n")
#max.diff1:  9.386859e-09 
##max.diff1:  8.897979e-08 
if (1e-7 < err ) stop("broydt hessian test failed.")


###### Example 2
sc2.f <- function(x){
n <- length(x)
vec <- 1:n
sum(vec * (exp(x) - x)) / n
}

sc2.g <- function(x){
n <- length(x)
vec <- 1:n
vec * (exp(x) - 1) / n
}

sc2.h <- function(x){
n <- length(x)
hess <- matrix(0, n, n)
vec <- 1:n
diag(hess) <- vec*exp(x)/n
hess
}

set.seed(123)
#x0 <- rexp(10, rate=0.1)
x0 <- rnorm(100)
exact <- sc2.g(x0)

ans1 <- grad(func=sc2.f, x=x0, method="complex")
#print(ans1, digits=18)
err <- max(abs(exact - ans1)/(1 + abs(exact)))
err
#[1] 0
if (1e-14 < err ) stop("sc2 grad complex test failed.")


ans2 <- grad(func=sc2.f, x=x0)
err <- max(abs(exact - ans2)/(1 + abs(exact)))
err
# [1] 9.968372e-08
##[1] 9.968372e-08
if (1e-7 < err ) stop("sc2 grad Richardson test failed.")


exact <- sc2.h(x0)

system.time(ah1 <- hessian(func=sc2.f, x=x0, method="complex"))
#elapsed 4.14 
err <- max(abs(exact - ah1)/(1 + abs(exact)))
err
#  [1] 1.13183e-13
## [1] 1.13183e-13
if (1e-12 < err ) stop("sc2 hessian complex test failed.")

system.time(ah2 <- hessian(func=sc2.f, x=x0))
#elapsed  2.537 
err <- max(abs(exact - ah2)/(1 + abs(exact)))
err
# [1] 3.415308e-06
##[1] 6.969096e-08
if (1e-5 < err ) stop("sc2 hessian Richardson test failed.")


###### Example 3
rosbkext.f <- function(p, cons=10){
n <- length(p)
j <- 1: (n/2)
tjm1 <- 2*j - 1
tj <- 2*j 
sum (cons^2*(p[tjm1]^2 - p[tj])^2 + (p[tj] - 1)^2)
}

rosbkext.g <- function(p, cons=10){
n <- length(p)
g <- rep(NA, n)
j <- 1: (n/2)
tjm1 <- 2*j - 1
tj <- 2*j 
g[tjm1] <- 4*cons^2 * p[tjm1] * (p[tjm1]^2 - p[tj])
g[tj] <- -2*cons^2 * (p[tjm1]^2 - p[tj]) + 2 * (p[tj] - 1)
g
}

set.seed(123)
p0 <- runif(10)
exact <- rosbkext.g(p0, cons=10)

numd1 <- grad(func=rosbkext.f, x=p0, cons=10, method="complex") # not as good 
#print(numd1, digits=18)

err <- max(abs(exact - numd1)/(1 + abs(exact)))
err
# [1] 1.203382e-16
##[1] 1.691132e-16
if (1e-15 < err ) stop("rosbkext grad complex test failed.")


numd2 <- grad(func=rosbkext.f, x=p0, cons=10)
err <- max(abs(exact - numd2)/(1 + abs(exact)))
err
# [1] 5.825746e-11
##[1] 4.020598e-10
if (1e-9 < err ) stop("rosbkext grad Richardson test failed.")


###### Example 4
genrose.f <- function(x, gs=100){ 
  # objective function 
  ## One generalization of the Rosenbrock banana valley function (n parameters) 
  n <- length(x) 
  1.0 + sum (gs*(x[1:(n-1)]^2 - x[2:n])^2 + (x[2:n] - 1)^2) 
  }
 
genrose.g <- function(x, gs=100){ 
  # vectorized gradient for genrose.f # Ravi Varadhan 2009-04-03 
  n <- length(x)
  gg <- as.vector(rep(0, n)) 
  tn <- 2:n 
  tn1 <- tn - 1 
  z1 <- x[tn] - x[tn1]^2 
  z2 <- 1 - x[tn] 
  gg[tn] <- 2 * (gs * z1 - z2) 
  gg[tn1] <- gg[tn1] - 4 * gs * x[tn1] * z1 
  return(gg) 
  } 
  
#set.seed(123)
#p0 <- runif(10)
p0 <- rep(pi, 1000)
exact <- genrose.g(p0, gs=100)

numd1 <- grad(func=genrose.f, x=p0, gs=100, method="complex")
err <- max(abs(exact - numd1)/(1 + abs(exact)))
err
# [1] 2.556789e-16
##[1] 2.556789e-16
if (1e-15 < err ) stop("genrose grad complex test failed.")

numd2 <- grad(func=genrose.f, x=p0, gs=100) 
err <- max(abs(exact - numd2)/(1 + abs(exact)))
err
# [1] 1.847244e-09
##[1] 1.847244e-09
if (1e-8 < err ) stop("genrose grad Richardson test failed.")

##### Example 5
# function of single variable
fchirp <- function(x, b, k) exp(-b*x) * sin(k*x^4)
dchirp <- function(x, b, k) exp(-b*x) * (4 * k * x^3 * cos(k*x^4) - b * sin(k*x^4))

x <- seq(-3, 3, length=500)
y <- dchirp(x, b=1, k=4)
#plot(x, y, type="l")
y1 <- grad(func=fchirp, x=x, b=1, k=4, method="complex")
#lines(x, y1, col=2, lty=2)
err <- max(abs(y-y1))
err
# [1] 4.048388e-10
##[1] 4.048388e-10
if (1e-9 < err ) stop("chirp grad complex test failed.")

y2 <- grad(func=fchirp, x=x, b=1, k=4)
#lines(x, y2, col=3, lty=2)
err <- max(abs(y-y2))
err
# [1] 5.219681e-08
##[1] 5.219681e-08
if (1e-7 < err ) stop("chirp grad Richardson test failed.")

#  check hessian
if(!require("numDeriv"))stop("this test requires numDeriv.")


####################################################################

#   sin tests

####################################################################


x <- 0.25 * pi
print(calc.h <- hessian(sin, x) )
print(anal.h <-  sin(x+pi))
cat("error: ", err <- max(abs(calc.h - anal.h)),"\n")
if( err > 1e-4) stop("hessian test 1 FAILED") # 1e-8 with d=0.01


func1 <- function(x) sum(sin(x))

x <- (0:2)*2*pi/2
#x <- (0:10)*2*pi/10
print(anal.h <-  matrix(0, length(x), length(x)))
print(calc.h <- hessian(func1, x) )
cat("error: ", err <- max(abs(anal.h - calc.h)),"\n")
if( err > 1e-10) stop("hessian test 2 FAILED")

funcD1 <- function(x) grad(sin,x)
print(calc.j <- jacobian(funcD1, x) )
cat("error: ", err <- max(abs(calc.h - calc.j)),"\n")
if( err > 1e-5) stop("hessian test 3 FAILED") # 1e-8 with d=0.01

####################################################################

#   exp tests

####################################################################

fun1e <- function(x) exp(2*x)
funD1e <- function(x) 2*exp(2*x)

x <- 1
print(anal.h <- 4*exp(2*x) )
print(calc.h  <- hessian(fun1e, x) )
cat("\nerror: ", err <- max(abs(calc.h - anal.h)),"\n")
if( err > 1e-3) stop("hessian test 5 FAILED") # 1e-7 with d=0.01

print(calc.j <- jacobian(funD1e, x) )
cat("\nerror: ", err <- max(abs(calc.j - anal.h)),"\n")
if( err > 1e-9) stop("hessian test 6 FAILED") # 1e-10 with d=0.01

fun1e <- function(x) sum(exp(2*x))
funD1e <- function(x) 2*exp(2*x)
x <- c(1,3,5)
print(anal.h <- diag(4*exp(2*x)) )

cat("\n************  d=0.01 works better here.*********\n")
print(calc.h  <- hessian(fun1e, x, method.args=list(d=0.01)) )

cat("\n relative error: \n")
print( err <-  (calc.h - anal.h) /(anal.h+1e-4))
cat("\n max relative error: ", err <- max(abs(err)),"\n")
# above is 901.4512 with d=0.0001

cat("\n error: \n")
print( err <-  calc.h - anal.h)
cat("\n max error: ", err <- max(abs(err)),"\n")
# above is 0.1670381 with d=0.0001

if( err > 1e-5) stop("hessian test 7 FAILED")

print(calc.j <- jacobian(funD1e, x) )
cat("error: ", err <- max(abs(calc.j - anal.h)),"\n")
if( err > 1e-5) stop("hessian test 8 FAILED") # 1e-6 with d=0.01

  # grad case 1 and 2 are special cases of jacobian, with a scalar rather than
  #   vector valued function. Case 3 differs only because of the interpretation
  #   that the vector result is a scalar function applied to each argument, and the
  #   thus the result has the same length as the argument.
  #   The code of grad could be consolidated to use jacobian.
  #   There is also some duplication in genD.

############################################################################

#    functions for gradient calculation

############################################################################

grad <- function (func, x, method="Richardson", side=NULL, 
   method.args=list(), ...) UseMethod("grad")

grad.default <- function(func, x, method="Richardson", side=NULL,
      method.args=list(), ...){
  # modified by Paul Gilbert from code by Xingqiao Liu.
  # case 1/ scalar arg, scalar result (case 2/ or 3/ code should work)
  # case 2/ vector arg, scalar result (same as special case jacobian)
  # case 3/ vector arg, vector result (of same length, really 1/ applied multiple times))
  f <- func(x, ...)
  n <- length(x)	 #number of variables in argument

  if (is.null(side)) side <- rep(NA, n)
  else {
       if(n != length(side)) 
          stop("Non-NULL argument 'side' should have the same length as x")
       if(any(1 != abs(side[!is.na(side)]))) 
          stop("Non-NULL argument 'side' should have values NA, +1, or -1.")
       }

  case1or3 <- n == length(f)

  if((1 != length(f)) & !case1or3)
  	 stop("grad assumes a scalar valued function.")

  if(method=="simple"){
    #  very simple numerical approximation
    args <- list(eps=1e-4) # default
    args[names(method.args)] <- method.args

    side[is.na(side)] <- 1
    eps <- rep(args$eps, n) * side

    if(case1or3) return((func(x+eps, ...)-f)/eps) 

    # now case 2
    df <- rep(NA,n)
    for (i in 1:n) {
      dx <- x
      dx[i] <- dx[i] + eps[i] 
      df[i] <- (func(dx, ...) - f)/eps[i]
     }
    return(df)
    } 
  else if(method=="complex"){ # Complex step gradient
    if (any(!is.na(side))) stop("method 'complex' does not support non-NULL argument 'side'.")
    eps <- .Machine$double.eps
    v <- try(func(x + eps * 1i, ...))
    if(inherits(v, "try-error")) 
      stop("function does not accept complex argument as required by method 'complex'.")
    if(!is.complex(v)) 
      stop("function does not return a complex value as required by method 'complex'.")
   
    if(case1or3) return(Im(v)/eps) 
    # now case 2
    h0 <- rep(0, n)
    g  <- rep(NA, n)
    for (i in 1:n) {
      h0[i] <- eps * 1i
      g[i] <- Im(func(x+h0, ...))/eps 
      h0[i]  <- 0
      }
    return(g)
    } 
  else if(method=="Richardson"){
    args <- list(eps=1e-4, d=0.0001, zero.tol=sqrt(.Machine$double.eps/7e-7), r=4, v=2, show.details=FALSE) # default
    args[names(method.args)] <- method.args
    d <- args$d
    r <- args$r
    v <- args$v
    show.details <- args$show.details
    a <- matrix(NA, r, n) 
    #b <- matrix(NA, (r - 1), n)
  
    #  first order derivatives are stored in the matrix a[k,i], 
    #  where the indexing variables k for rows(1 to r), i for columns (1 to n),
    #  r is the number of iterations, and n is the number of variables.
  

    h <- abs(d*x) + args$eps * (abs(x) < args$zero.tol)
    pna <- (side == 1)  & !is.na(side) # double these on plus side
    mna <- (side == -1) & !is.na(side) # double these on minus side

    for(k in 1:r)  { # successively reduce h		    
       ph <- mh <- h
       ph[pna] <- 2 * ph[pna] 
       ph[mna] <- 0           
       mh[mna] <- 2 * mh[mna] 
       mh[pna] <- 0           

       if(case1or3)  a[k,] <- (func(x + ph, ...) -  func(x - mh, ...))/(2*h)
       else for(i in 1:n)  {
    	 if((k != 1) && (abs(a[(k-1),i]) < 1e-20)) a[k,i] <- 0 #some func are unstable near zero
    	 else  a[k,i] <- (func(x + ph*(i==seq(n)), ...) - 
    			  func(x - mh*(i==seq(n)), ...))/(2*h[i])
    	 }
       if (any(is.na(a[k,]))) stop("function returns NA at ", h," distance from x.")
       h <- h/v     # Reduced h by 1/v.
       }	

   if(show.details)  {
        cat("\n","first order approximations", "\n")		
        print(a, 12)
    }

  #------------------------------------------------------------------------
  # 1 Applying Richardson Extrapolation to improve the accuracy of 
  #   the first and second order derivatives. The algorithm as follows:
  #
  #   --  For each column of the derivative matrix a,
  #	  say, A1, A2, ..., Ar, by Richardson Extrapolation, to calculate a
  #	  new sequence of approximations B1, B2, ..., Br used the formula
  #
  #	     B(i) =( A(i+1)*4^m - A(i) ) / (4^m - 1) ,  i=1,2,...,r-m
  #
  #		N.B. This formula assumes v=2.
  #
  #   -- Initially m is taken as 1  and then the process is repeated 
  #	 restarting with the latest improved values and increasing the 
  #	 value of m by one each until m equals r-1
  #
  # 2 Display the improved derivatives for each
  #   m from 1 to r-1 if the argument show.details=T.
  #
  # 3 Return the final improved  derivative vector.
  #-------------------------------------------------------------------------
  
    for(m in 1:(r - 1)) {	  
       a <- (a[2:(r+1-m),,drop=FALSE]*(4^m)-a[1:(r-m),,drop=FALSE])/(4^m-1)
       if(show.details & m!=(r-1) )  {
  	  cat("\n","Richarson improvement group No. ", m, "\n") 	  
  	  print(a[1:(r-m),,drop=FALSE], 12)
  	}
     }
  return(c(a))
  } else stop("indicated method ", method, "not supported.")
}
  

jacobian <- function (func, x, method="Richardson", side=NULL,
                              method.args=list(), ...) UseMethod("jacobian")

jacobian.default <- function(func, x, method="Richardson", side=NULL,
      method.args=list(), ...){
  f <- func(x, ...)
  n <- length(x)	 #number of variables.

  if (is.null(side)) side <- rep(NA, n)
  else {
       if(n != length(side)) 
          stop("Non-NULL argument 'side' should have the same length as x")
       if(any(1 != abs(side[!is.na(side)]))) 
          stop("Non-NULL argument 'side' should have values NA, +1, or -1.")
       }

  if(method=="simple"){
    #  very simple numerical approximation
    args <- list(eps=1e-4) # default
    args[names(method.args)] <- method.args

    side[is.na(side)] <- 1
    eps <- rep(args$eps, n) * side

    df <-matrix(NA, length(f), n)
    for (i in 1:n) {
      dx <- x
      dx[i] <- dx[i] + eps[i] 
      df[,i] <- (func(dx, ...) - f)/eps[i]
     }
    return(df)
    } 
  else if(method=="complex"){ # Complex step gradient
    if (any(!is.na(side))) stop("method 'complex' does not support non-NULL argument 'side'.")
    # Complex step Jacobian
    eps <- .Machine$double.eps
    h0  <-  rep(0, n)
    h0[1] <- eps * 1i
    v <- try(func(x+h0, ...))
    if(inherits(v, "try-error")) 
      stop("function does not accept complex argument as required by method 'complex'.")
    if(!is.complex(v)) 
      stop("function does not return a complex value as required by method 'complex'.")
  
    h0[1]  <- 0
    jac <- matrix(NA, length(v), n)
    jac[, 1] <- Im(v)/eps
    if (n == 1) return(jac)
    for (i in 2:n) {
      h0[i] <- eps * 1i
      jac[, i] <- Im(func(x+h0, ...))/eps 
      h0[i]  <- 0
      }
    return(jac)
    } 
  else if(method=="Richardson"){
    args <- list(eps=1e-4, d=0.0001, zero.tol=sqrt(.Machine$double.eps/7e-7), 
                r=4, v=2, show.details=FALSE) # default
    args[names(method.args)] <- method.args
    d <- args$d
    r <- args$r
    v <- args$v 	  
    a <- array(NA, c(length(f),r, n) )
  
    h <- abs(d*x) + args$eps * (abs(x) < args$zero.tol)
    pna <- (side == 1)  & !is.na(side) # double these on plus side
    mna <- (side == -1) & !is.na(side) # double these on minus side

    for(k in 1:r)  { # successively reduce h		 
       ph <- mh <- h
       ph[pna] <- 2 * ph[pna] 
       ph[mna] <- 0           
       mh[mna] <- 2 * mh[mna] 
       mh[pna] <- 0           

       for(i in 1:n)  {
    	 a[,k,i] <- (func(x + ph*(i==seq(n)), ...) -  
     		     func(x - mh*(i==seq(n)), ...))/(2*h[i])
    	 #if((k != 1)) a[,(abs(a[,(k-1),i]) < 1e-20)] <- 0 #some func are unstable near zero
    	 }
       h <- h/v     # Reduced h by 1/v.
       }     

   for(m in 1:(r - 1)) {	  
       a <- (a[,2:(r+1-m),,drop=FALSE]*(4^m)-a[,1:(r-m),,drop=FALSE])/(4^m-1)
     }
  # drop second dim of a, which is now 1 (but not other dim's even if they are 1
  return(array(a, dim(a)[c(1,3)]))  
  } else stop("indicated method ", method, "not supported.")
}

hessian <- function (func, x, method="Richardson",
                              method.args=list(), ...) UseMethod("hessian")

hessian.default <- function(func, x, method="Richardson",
      method.args=list(), ...){  

 if(1!=length(func(x, ...)))
       stop("Richardson method for hessian assumes a scalar valued function.")

 if(method=="complex"){ # Complex step hessian
   args <- list(eps=1e-4, d=0.1, 
      zero.tol=sqrt(.Machine$double.eps/7e-7), r=4, v=2)
   args[names(method.args)] <- method.args
   # the CSD part of this uses eps=.Machine$double.eps
   # but the jacobian is Richardson and uses method.args
   fn <- function(x, ...){
           grad(func=func, x=x, method="complex", side=NULL,
	   method.args=list(eps=.Machine$double.eps), ...)
	   }

   return(jacobian(func=fn, x=x, method="Richardson", side=NULL,
                    method.args=args, ...))
   } 
 else if(method != "Richardson")  stop("method not implemented.")

   args <- list(eps=1e-4, d=0.1, zero.tol=sqrt(.Machine$double.eps/7e-7), 
                r=4, v=2, show.details=FALSE) # default
   args[names(method.args)] <- method.args
   D <- genD(func, x, method=method, method.args=args, ...)$D
   if(1!=nrow(D)) stop("BUG! should not get here.")
   H <- diag(NA,length(x))
   u <- length(x)
   for(i in 1:length(x))
      for(j in 1:i){ 
         u <- u + 1
         H[i,j] <- D[,u]
         }

   H <- H + t(H)
   diag(H) <- diag(H)/2
   H
  }


#######################################################################

#               Bates & Watts   D matrix calculation

#######################################################################

genD <- function(func, x, method="Richardson",
                   method.args=list(), ...)UseMethod("genD")

genD.default <- function(func, x, method="Richardson",
      method.args=list(), ...){
  #   additional cleanup by Paul Gilbert (March, 2006)
  #   modified substantially by Paul Gilbert (May, 1992)
  #    from original code by Xingqiao Liu,   May, 1991.
  
  #  This function is not optimized for S speed, but is organized in 
  # the same way it could be (was) implemented in C, to facilitate checking.
  
  #  v  reduction factor for Richardson iterations. This could
  #	 be a parameter but the way the formula is coded it is assumed to be 2.
 
    if(method != "Richardson")  stop("method not implemented.")
    args <- list(eps=1e-4, d=0.0001, zero.tol=sqrt(.Machine$double.eps/7e-7),
              r=4, v=2) # default
    args[names(method.args)] <- method.args
    d <- args$d
    r <- args$r
    v <- args$v
    if (v!=2) stop("The current code assumes v is 2 (the default).")	 

    f0 <- func(x, ...)   #f0 is the value of the function at x.

    n <- length(x)  #  number of parameters (theta)
    h0 <- abs(d*x) + args$eps * (abs(x) < args$zero.tol)
    D <- matrix(0, length(f0),(n*(n + 3))/2)
    #length(f0) is the dim of the sample space
    #(n*(n + 3))/2 is the number of columns of matrix D.( first
    #	der. & lower triangle of Hessian)
    Daprox <-  matrix(0,length(f0),r) 
    Hdiag  <-  matrix(0,length(f0),n)
    Haprox <-  matrix(0,length(f0),r)

    for(i in 1:n){    # each parameter  - first deriv. & hessian diagonal
          h <-h0
          for(k in 1:r){  # successively reduce h 
             f1 <- func(x+(i==(1:n))*h, ...)
             f2 <- func(x-(i==(1:n))*h, ...) 
             #f1 <- do.call("func",append(list(x+(i==(1:n))*h), func.args))
             #f2 <- do.call("func",append(list(x-(i==(1:n))*h), func.args))
             Daprox[,k] <- (f1 - f2)  / (2*h[i])    # F'(i) 
             Haprox[,k] <- (f1-2*f0+f2)/ h[i]^2     # F''(i,i) hessian diagonal
             h <- h/v	  # Reduced h by 1/v.
             }
          for(m in 1:(r - 1))
             for ( k in 1:(r-m)){
                Daprox[,k]<-(Daprox[,k+1]*(4^m)-Daprox[,k])/(4^m-1)
        	Haprox[,k]<-(Haprox[,k+1]*(4^m)-Haprox[,k])/(4^m-1)
                }
          D[,i] <- Daprox[,1]
          Hdiag[,i] <- Haprox[,1]
          }	 
    u <- n
  
    for(i in 1:n){   # 2nd derivative  - do lower half of hessian only
       for(j in 1:i){
          u <- u + 1
             if (i==j) D[,u] <- Hdiag[,i]
             else {
               h <-h0
               for(k in 1:r){  # successively reduce h 
        	  f1 <- func(x+(i==(1:n))*h + (j==(1:n))*h, ...)
        	  f2 <- func(x-(i==(1:n))*h - (j==(1:n))*h, ...)
        	  Daprox[,k]<- (f1 - 2*f0 + f2 -
        			   Hdiag[,i]*h[i]^2 - 
        			   Hdiag[,j]*h[j]^2)/(2*h[i]*h[j])  # F''(i,j)  
        	  h <- h/v     # Reduced h by 1/v.
        	  }
               for(m in 1:(r - 1))
        	  for ( k in 1:(r-m))
        	     Daprox[,k]<-(Daprox[,k+1]*(4^m)-Daprox[,k])/(4^m-1)
               D[,u] <- Daprox[,1]
               }
          }  
       }
  D <- list(D=D, p=length(x), f0=f0, func=func, x=x, d=d,
            method=method, method.args=args)# Darray constructor (genD.default)
  class(D) <- "Darray"
  invisible(D)
  }
  

\name{numDeriv-package}
\alias{numDeriv-package}
\alias{numDeriv.Intro}
\docType{package}

\title{Accurate Numerical Derivatives}

\description{Calculate (accurate) numerical approximations to derivatives.}

\details{
The main functions are
\preformatted{
grad	  to calculate the gradient (first derivative) of a scalar 
  	  real valued function (possibly applied to all elements 
  	  of a vector argument).

jacobian  to calculate the gradient of a real m-vector valued
  	  function with real n-vector argument.

hessian   to calculate the Hessian (second derivative) of a scalar 
  	  real valued function with real n-vector argument.

genD	  to calculate the gradient and second derivative of a
  	  real m-vector valued function with real n-vector 
	  argument.
}

}
\author{Paul Gilbert, based on work by Xingqiao Liu, and Ravi Varadhan (who wrote complex-step derivative codes)}
\references{
   Linfield, G. R. and Penny, J. E. T. (1989) \emph{Microcomputers in Numerical 
   Analysis}. New York: Halsted Press.

  Fornberg, B. and Sloan, D, M. (1994) ``A review of pseudospectral methods 
  for solving partial differential equations.'' \emph{Acta Numerica}, 3, 203-267.

  Lyness, J. N. and Moler, C. B. (1967) ``Numerical Differentiation of Analytic 
   Functions.'' \emph{SIAM Journal for Numerical Analysis},
    4(2), 202-210.
}
\keyword{package}

\name{grad}
\alias{grad}
\alias{grad.default}
\title{Numerical Gradient of a Function}
\description{Calculate the gradient of a function by numerical approximation.}
\usage{
     grad(func, x, method="Richardson", side=NULL, method.args=list(), ...) 

    \method{grad}{default}(func, x, method="Richardson", side=NULL,
      method.args=list(), ...)
 }
\arguments{
    \item{func}{a function with a scalar real result (see details).}
    \item{x}{a real scalar or vector argument to func, indicating the 
      point(s) at which the gradient is to be calculated.}
    \item{method}{one of \code{"Richardson"}, \code{"simple"}, or 
       \code{"complex"} indicating the method to use for the approximation.}
    \item{method.args}{arguments passed to method. Arguments not specified 
       remain with their default values as specified in details}
    \item{side}{an indication of whether one-sided derivatives should be
       attempted (see details).}
    \item{...}{an additional arguments passed to \code{func}.
          WARNING: None of these should have names matching other arguments of this function.}
}
\value{A real scalar or vector of the approximated gradient(s).}

\details{
   The function \code{grad} calculates a numerical approximation of the 
   first derivative of \code{func} at the point \code{x}. Any additional 
   arguments in \dots are also passed to \code{func}, but the gradient is not
   calculated with respect to these additional arguments.
   It is assumed \code{func}  is a scalar value function. If a vector \code{x} 
   produces a scalar
   result then \code{grad} returns the numerical approximation of the gradient
   at the point \code{x} (which has the same length as \code{x}).
   If a vector \code{x} produces a vector result then the result must have the
   same length as \code{x}, and it is assumed that this corresponds to applying
   the function to each of its arguments (for example, \code{sin(x)}). 
   In this case \code{grad} returns the
   gradient at each of the points in \code{x} (which also has the same length 
   as \code{x} -- so be careful). An alternative for vector valued functions is
   provided by \code{\link{jacobian}}.
  
   If method is "simple", the calculation is done using a simple epsilon
   difference. 
   For method "simple" \code{method.args=list(eps=1e-4)} is the
   default. Only \code{eps} is used by this method.

   If method is "complex", the calculation is done using the complex step
   derivative approach of Lyness and Moler, described in  Squire and Trapp. 
   This method requires that the function be able to handle complex valued 
   arguments and return the appropriate complex valued result, 
   even though the user may only be interested in the real-valued derivatives. 
   It also requires that the complex function be analytic. (This might be thought 
   of as the complex equivalent of the requirement for continuity and smoothness 
   of a real valued function.) 
   So, while this method is extremely powerful it is applicable to
   a very restricted class of functions. \emph{Avoid this method if you do not 
   know that your function is suitable. Your mistake may not be caught and the
   results will be spurious.}
   For cases where it can be used,
   it is faster than Richardson's extrapolation, and
   it also provides gradients that are correct to machine precision (16 digits).   
   For method "complex", \code{method.args} is ignored.
   The algorithm uses an \code{eps} of \code{.Machine$double.eps} which cannot
   (and should not) be modified. 

   If method is "Richardson", the calculation
   is done by Richardson's extrapolation (see e.g. Linfield and Penny, 1989,
   or Fornberg and Sloan, 1994.)
   This method should be used if accuracy, as opposed to speed, is important
   (but see method "complex" above). 
   For this method 
   \code{method.args=list(eps=1e-4, d=0.0001, zero.tol=sqrt(.Machine$double.eps/7e-7), 
   r=4, v=2, show.details=FALSE)} is set as the default.
    \code{d} gives the fraction of \code{x} to use for the initial numerical 
      approximation. The default means the initial approximation uses
      \code{0.0001 * x}.
    \code{eps} is used instead of \code{d} for elements of \code{x} which are 
       zero (absolute value less than zero.tol).
    \code{zero.tol} tolerance used for deciding which elements of \code{x} are 
       zero.
    \code{r} gives the number of Richardson improvement iterations (repetitions
       with successly smaller \code{d}. The default \code{4} general provides 
       good results, but this can be increased to \code{6} for improved
       accuracy at the cost of more evaluations.
    \code{v} gives the reduction factor.
    \code{show.details} is a logical indicating if detailed calculations should 
        be shown.
   
  The general approach in the Richardson method is to iterate for \code{r} 
  iterations from initial 
  values for interval value \code{d},  using reduced factor \code{v}.
  The the first order approximation to the derivative with respect 
  to \eqn{x_{i}}{x_{i}} is

      \deqn{f'_{i}(x) = <f(x_{1},\dots,x_{i}+d,\dots,x_{n}) -
               f(x_{1},\dots,x_{i}-d,\dots,x_{n})>/(2*d)}{%
	    f'_{i}(x) = <f(x_{1},\dots,x_{i}+d,\dots,x_{n}) -
               f(x_{1},\dots,x_{i}-d,\dots,x_{n})>/(2*d)}
       
  This is repeated \code{r} times  with successively smaller \code{d}  and 
  then Richardson extraplolation is applied.
  
  If elements of \code{x} are near zero the multiplicative interval calculation
  using \code{d} does not work, and for these elements an additive calculation
  using \code{eps} is done instead. The argument \code{zero.tol} is used
  determine if an element should be considered too close to zero. 
  In the iterations, interval is successively reduced to eventual 
  be \code{d/v^r} and the square of this value is used in second derivative 
  calculations (see \code{\link{genD}}) so the 
  default \code{zero.tol=sqrt(.Machine$double.eps/7e-7)} is set to ensure the
  interval is bigger than \code{.Machine$double.eps} with the default \code{d},
  \code{r}, and \code{v}.
  
  If \code{side} is \code{NULL} then it is assumed that the point at which the
  calculation is being done is interior to the domain of the function. If the
  point is on the boundary of the domain then \code{side} can be used to 
  indicate which side of the point \code{x} should be used for the calculation.
  If not \code{NULL} then it should be a vector of the same length as \code{x}
  and have values \code{NA}, \code{+1}, or \code{-1}. \code{NA} indicates that
  the usual calculation will be done, while \code{+1}, or \code{-1} indicate
  adding or subtracting from the parameter point \code{x}. The argument
  \code{side} is not supported for all methods.
  
  Since usual calculation with method "simple" uses only a small \code{eps} 
  step to one side, the only effect of argument \code{side} is to determine the
  direction of the step. The usual calculation with method "Richardson" is 
  symmetric, using steps to both sides. The effect of argument \code{side} 
  is to take a double sized step to one side, and no step to the other side.
  This means that the center of the Richardson extrapolation steps is moving
  slightly in the reduction, and is not exactly on the boundary. 
  (Warning: I am not aware of theory or published
  experimental evidence to support this, but the results in my limited testing
  seem good.)
}
\references{ 
   Linfield, G. R. and Penny, J. E. T. (1989) \emph{Microcomputers in Numerical 
   Analysis}. New York: Halsted Press.

  Fornberg, B. and Sloan, D, M. (1994) ``A review of pseudospectral methods 
  for solving partial differential equations.'' \emph{Acta Numerica}, 3, 203-267.

  Lyness, J. N. and Moler, C. B. (1967) ``Numerical Differentiation of Analytic 
   Functions.'' \emph{SIAM Journal for Numerical Analysis},
    4(2), 202-210.

  Squire, William and Trapp, George (1998) ``Using Complex Variables to Estimate
   Derivatives of Real Functions.'' \emph{SIAM Rev},
    40(1), 110-112.
}
\seealso{
  \code{\link{jacobian}},
  \code{\link{hessian}},
  \code{\link{genD}},
  \code{\link[stats]{numericDeriv}}
   }
\examples{
  grad(sin, pi)
  grad(sin, (0:10)*2*pi/10)
  func0 <- function(x){ sum(sin(x))  }
  grad(func0 , (0:10)*2*pi/10)

  func1 <- function(x){ sin(10*x) - exp(-x) }

  curve(func1,from=0,to=5)

  x <- 2.04
  numd1 <- grad(func1, x)
  exact <- 10*cos(10*x) + exp(-x)
  c(numd1, exact, (numd1 - exact)/exact)

  x <- c(1:10)
  numd1 <- grad(func1, x)
  numd2 <- grad(func1, x, "complex")
  exact <- 10*cos(10*x) + exp(-x)
  cbind(numd1, numd2, exact, (numd1 - exact)/exact, (numd2 - exact)/exact)

  sc2.f <- function(x){
    n <- length(x)
    sum((1:n) * (exp(x) - x)) / n
    }

  sc2.g <- function(x){
    n <- length(x)
    (1:n) * (exp(x) - 1) / n
    }

  x0 <- rnorm(100)
  exact <- sc2.g(x0)

  g <- grad(func=sc2.f, x=x0)
  max(abs(exact - g)/(1 + abs(exact)))

  gc <- grad(func=sc2.f, x=x0, method="complex")
  max(abs(exact - gc)/(1 + abs(exact)))

  f <- function(x) if(x[1]<=0) sum(sin(x)) else  NA
  grad(f, x=c(0,0), method="Richardson", side=c(-1,  1))
}
\keyword{multivariate}

\name{hessian}
\alias{hessian}
\alias{hessian.default}

\title{Calculate Hessian Matrix}
\description{Calculate a numerical approximation to the Hessian matrix of a 
function at a parameter value.}
\usage{
    hessian(func, x, method="Richardson", method.args=list(), ...)

    \method{hessian}{default}(func, x, method="Richardson",
        method.args=list(), ...)
}
\arguments{
    \item{func}{a function for which the first (vector) argument 
        is used as a parameter vector.}
    \item{x}{the parameter vector first argument to func.}
    \item{method}{one of \code{"Richardson"} or \code{"complex"} indicating 
    the method to use for the approximation.}
    \item{method.args}{arguments passed to method.  See \code{\link{grad}}. 
       (Arguments not specified remain with their default values.)}
    \item{...}{an additional arguments passed to \code{func}.
          WARNING: None of these should have names matching other arguments of this function.}
}
\value{An n by n matrix of the Hessian of the function calculated at the 
       point \code{x}.}
\details{
  The function \code{hessian} calculates an numerical approximation to 
  the n x n second derivative of a scalar real valued function with n-vector
  argument. 
  
  The argument \code{method} can be \code{"Richardson"} or \code{"complex"}.
  Method \code{"simple"} is not supported. 
  
  For method \code{"complex"} the Hessian matrix is calculated as the Jacobian
  of the gradient. The function \code{grad} with method "complex" is used, 
  and \code{method.args} is ignored for this (an \code{eps} of 
  \code{.Machine$double.eps} is used). 
  However,  \code{jacobian} is used in the second step, with method 
  \code{"Richardson"} and argument \code{method.args} is used for this. 
  The default is
  \code{method.args=list(eps=1e-4, d=0.1, zero.tol=sqrt(.Machine$double.eps/7e-7), 
   r=4, v=2, show.details=FALSE)}. (These are the defaults for \code{hessian} 
   with method \code{"Richardson"}, which are slightly different from the defaults 
   for \code{jacobian} with method \code{"Richardson"}.)
  See addition comments in \code{\link{grad}} before choosing 
  method \code{"complex"}.
  
  Methods \code{"Richardson"} uses \code{\link{genD}} and extracts the 
  second derivative. For this method 
   \code{method.args=list(eps=1e-4, d=0.1, zero.tol=sqrt(.Machine$double.eps/7e-7), 
   r=4, v=2, show.details=FALSE)} is set as the default. \code{hessian} does
   one evaluation of \code{func} in order to do some error checking before
   calling \code{genD}, so the number of function evaluations will be one more
   than indicated for \code{\link{genD}}.

  The argument \code{side} is not supported for second derivatives and since
  \dots are passed to \code{func} there may be no error message if it is
  specified.
  }
\seealso{
    \code{\link{jacobian}},
    \code{\link{grad}},
    \code{\link{genD}}
}
\examples{
  sc2.f <- function(x){
    n <- length(x)
    sum((1:n) * (exp(x) - x)) / n
    }

  sc2.g <- function(x){
    n <- length(x)
    (1:n) * (exp(x) - 1) / n
    }

  x0 <- rnorm(5)
  hess <- hessian(func=sc2.f, x=x0)
  hessc <- hessian(func=sc2.f, x=x0, "complex")
  all.equal(hess, hessc, tolerance = .Machine$double.eps)
  
#  Hessian = Jacobian of the gradient
  jac  <- jacobian(func=sc2.g, x=x0)
  jacc <- jacobian(func=sc2.g, x=x0, "complex")
  all.equal(hess, jac, tolerance = .Machine$double.eps)
  all.equal(hessc, jacc, tolerance = .Machine$double.eps)
}
\keyword{multivariate}

\name{genD}
\alias{genD}
\alias{genD.default}

\title{Generate Bates and Watts D Matrix}
\description{Generate a matrix of function derivative information.}
\usage{
    genD(func, x, method="Richardson",
                   method.args=list(), ...)
    \method{genD}{default}(func, x, method="Richardson",
      method.args=list(), ...)
}
\arguments{
    \item{func}{a function for which the first (vector) argument 
        is used as a parameter vector.}
    \item{x}{The parameter vector first argument to \code{func}.}
    \item{method}{one of \code{"Richardson"} or \code{"simple"} indicating 
    the method to use for the aproximation.}
    \item{method.args}{arguments passed to method.  See \code{\link{grad}}. 
       (Arguments not specified remain with their default values.)}
    \item{...}{any additional arguments passed to \code{func}.
          WARNING: None of these should have names matching other arguments of this function.}
}
\value{
A list with elements as follows:
   \code{D} is a matrix of first and second order partial
      derivatives organized in the same manner as Bates and 
      Watts, the number of rows is equal to the length of the result of
      \code{func}, the first p columns are the Jacobian, and the 
      next p(p+1)/2 columns are the lower triangle of the second derivative
      (which is the Hessian for a scalar valued \code{func}).
   \code{p} is the length of \code{x} (dimension of the parameter space).
   \code{f0} is the function value at the point where the matrix \code{D} 
        was calculated. 
   The  \code{genD} arguments \code{func}, \code{x}, \code{d}, \code{method},
   and  \code{method.args} also are returned in the list.
}
\details{
   The derivatives are calculated numerically using Richardson improvement.
   Methods "simple" and "complex" are not supported in this function.
   The "Richardson" method calculates a numerical approximation of the first 
   and second derivatives of \code{func} at the point \code{x}. 
   For a scalar valued function these are the gradient vector and 
   Hessian matrix. (See \code{\link{grad}} and \code{\link{hessian}}.)
   For a vector valued function the first derivative is the Jacobian matrix 
   (see \code{\link{jacobian}}). 
   For the Richardson method 
   \code{method.args=list(eps=1e-4, d=0.0001, zero.tol=sqrt(.Machine$double.eps/7e-7), 
   r=4, v=2)} is set as the default.
   See \code{\link{grad}}
   for more details on the Richardson's extrapolation parameters. 

   A simple approximation to the first order derivative with respect 
   to \eqn{x_i}{x_i} is 

   \deqn{f'_{i}(x) = <f(x_{1},\dots,x_{i}+d,\dots,x_{n}) -
               f(x_{1},\dots,x_{i}-d,\dots,x_{n})>/(2*d)}{%
 	 f'_{i}(x) = <f(x_{1},\dots,x_{i}+d,\dots,x_{n}) -
               f(x_{1},\dots,x_{i}-d,\dots,x_{n})>/(2*d)}

  A simple approximation to the second order derivative with respect 
  to \eqn{x_i}{x_i} is 

  \deqn{f''_{i}(x) = <f(x_{1},\dots,x_{i}+d,\dots,x_{n}) -
                   2 *f(x_{1},\dots,x_{n}) +
                    f(x_{1},\dots,x_{i}-d,\dots,x_{n})>/(d^2) }{%
	f''_{i}(x) = <f(x_{1},\dots,x_{i}+d,\dots,x_{n}) -
                   2 *f(x_{1},\dots,x_{n}) +
                    f(x_{1},\dots,x_{i}-d,\dots,x_{n})>/(d^2) }	    

   The second order derivative with respect to \eqn{x_i, x_j}{x_i, x_j} is 

  \deqn{f''_{i,j}(x) = <f(x_{1},\dots,x_{i}+d,\dots,x_{j}+d,\dots,x_{n}) -
                    2 *f(x_{1},\dots,x_{n}) + }{%
        f''_{i,j}(x) = <f(x_{1},\dots,x_{i}+d,\dots,x_{j}+d,\dots,x_{n}) -
                    2 *f(x_{1},\dots,x_{n}) + }

  \deqn{f(x_{1},\dots,x_{i}-d,\dots,x_{j}-d,\dots,x_{n})>/(2*d^2) -
		      (f''_{i}(x) + f''_{j}(x))/2 }{%
        f(x_{1},\dots,x_{i}-d,\dots,x_{j}-d,\dots,x_{n})>/(2*d^2) -
		      (f''_{i}(x) + f''_{j}(x))/2 }


   Richardson's extrapolation is based on these formula with the \code{d} 
   being reduced in the extrapolation iterations. In the code, \code{d} is
   scaled to accommodate parameters of different magnitudes. 

   \code{genD} does \code{1 + r (N^2 + N)} evaluations of the function
   \code{f}, where \code{N} is the length of \code{x}.
}

\references{ 
   Linfield, G.R. and Penny, J.E.T. (1989) "Microcomputers in Numerical Analysis."
    Halsted Press.
   
   Bates, D.M. & Watts, D. (1980), "Relative Curvature Measures of Nonlinearity."
   J. Royal Statistics Soc. series B, 42:1-25

   Bates, D.M. and Watts, D. (1988) "Non-linear Regression Analysis and Its Applications."
   Wiley.
}

\seealso{
   \code{\link{hessian}}, 
   \code{\link{grad}}
}
\examples{
    func <- function(x){c(x[1], x[1], x[2]^2)}
    z <- genD(func, c(2,2,5))
}
\keyword{multivariate}

\name{jacobian}
\alias{jacobian}
\alias{jacobian.default}
\title{Gradient of a Vector Valued Function}
\description{
Calculate the m by n numerical approximation of the gradient of a real
m-vector valued function with n-vector argument.
}
\usage{
    jacobian(func, x, method="Richardson", side=NULL, method.args=list(), ...) 

    \method{jacobian}{default}(func, x, method="Richardson", side=NULL,
       method.args=list(), ...)
}
\arguments{
    \item{func}{a function with a real (vector) result.}
    \item{x}{a real or real vector argument to func, indicating the point 
       at which the gradient is to be calculated.}
    \item{method}{one of \code{"Richardson"}, \code{"simple"}, or 
       \code{"complex"} indicating the method to use for the approximation.}
    \item{method.args}{arguments passed to method. See \code{\link{grad}}. 
       (Arguments not specified remain with their default values.)}
    \item{...}{any additional arguments passed to \code{func}.
          WARNING: None of these should have names matching other arguments of this function.}
    \item{side}{an indication of whether one-sided derivatives should be
       attempted (see details in function \code{\link{grad}}).}
}
\value{A real m by n matrix.}
\details{
   For \eqn{f:R^n -> R^m}{f:R^n -> R^m} calculate the \eqn{m x n}{m x n} 
   Jacobian \eqn{dy/dx}{dy/dx}.
   The function \code{jacobian} calculates a numerical approximation of the 
   first derivative of \code{func} at the point \code{x}. Any additional 
   arguments in \dots are also passed to \code{func}, but the gradient is not
   calculated with respect to these additional arguments.

   If method is "Richardson", the calculation is done by 
   Richardson's extrapolation. See \code{link{grad}} for more details.
   For this method  \code{method.args=list(eps=1e-4, d=0.0001, 
   zero.tol=sqrt(.Machine$double.eps/7e-7), r=4, v=2, show.details=FALSE)} 
   is set as the default.

   If method is "simple", the calculation is done using a simple epsilon
   difference. 
   For method "simple" \code{method.args=list(eps=1e-4)} is the
   default. Only \code{eps} is used by this method.

   If method is "complex", the calculation is done using the complex step
   derivative approach. See addition comments in \code{\link{grad}} before
   choosing this method.  
   For method "complex", \code{method.args} is ignored.
   The algorithm uses an \code{eps} of \code{.Machine$double.eps} which cannot
   (and should not) be modified. 
}
\seealso{
  \code{\link{grad}},
  \code{\link{hessian}},
  \code{\link[stats]{numericDeriv}}
  }
\examples{
   func2 <- function(x) c(sin(x), cos(x))
   x <- (0:1)*2*pi
   jacobian(func2, x)
   jacobian(func2, x, "complex")
}
\keyword{multivariate}

\name{00.numDeriv.Intro}
\alias{00.numDeriv.Intro}
\docType{package}

\title{Accurate Numerical Derivatives}

\description{Calculate (accurate) numerical approximations to derivatives.}

\details{ See \code{\link{numDeriv-package}} ( in the help system use
   package?numDeriv or ?"numDeriv-package") for an overview.
}
\keyword{package}
